\name{ar}
\alias{ar}
\non_function{}
\title{ar data}
\usage{data(ar)}
\description{
The \code{ar} data frame has 60 rows and 4 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{x1}{a numeric vector}
    \item{x2}{a numeric vector}
    \item{x3}{a numeric vector}
    \item{y}{a numeric vector}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.2}
\examples{}
\keyword{datasets}
\eof
\name{bliss}
\alias{bliss}
\non_function{}
\title{Bliss data}
\usage{data(bliss)}
\description{
The \code{bliss} data frame has 8 rows and 4 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{Dose}{a numeric vector}
    \item{Killed}{a numeric vector}
    \item{Total}{a numeric vector}
    \item{y}{a numeric vector}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.20}
\examples{}
\keyword{datasets}
\eof
\name{calcium}
\alias{calcium}
\non_function{}
\title{Calcium data}
\usage{data(calcium)}
\description{
Calcium uptake of cells suspended in a solution of radioactive calcium. \cr
The \code{calcium} data frame has 27 rows and 2 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{Time}{a numeric vector}
    \item{y}{a numeric vector}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.13}
\examples{}
\keyword{datasets}
\eof
\name{carinsuk}
\alias{carinsuk}
\non_function{}
\title{Car insurance data}
\usage{data(carinsuk)}
\description{
The \code{carinsuk} data frame has 128 rows and 5 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{OwnerAge}{a factor with levels}
    \item{OwnerAge}{\code{17-20} }
    \item{OwnerAge}{\code{21-24} }
    \item{OwnerAge}{\code{25-29} }
    \item{OwnerAge}{\code{30-34} }
    \item{OwnerAge}{\code{35-39} }
    \item{OwnerAge}{\code{40-49} }
    \item{OwnerAge}{\code{50-59} }
    \item{OwnerAge}{\code{60+} }
    \item{Model}{a factor with levels}
    \item{Model}{\code{A} }
    \item{Model}{\code{B} }
    \item{Model}{\code{C} }
    \item{Model}{\code{D} }
    \item{CarAge}{a factor with levels}
    \item{CarAge}{\code{0-3} }
    \item{CarAge}{\code{10+} }
    \item{CarAge}{\code{4-7} }
    \item{CarAge}{\code{8-9} }
    \item{NClaims}{a numeric vector}
    \item{AvCost}{a numeric vector}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.16}
\examples{}
\keyword{datasets}
\eof
\name{carr}
\alias{carr}
\non_function{}
\title{n-Pentane data}
\usage{data(carr)}
\description{Reaction rate for Catalytic Isomerization of n-Pentane to
Isopentane \cr
The \code{carr} data frame has 24 rows and 4 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{x1}{partial pressure of hydrogen}
    \item{x2}{partial pressure of n-pentane}
    \item{x3}{partial pressure of iso-pentane}
    \item{y}{rate of disappearance of n-pentane}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.15}
\examples{}
\keyword{datasets}
\eof
\name{cellular}
\alias{cellular}
\non_function{}
\title{Cellular differentiation data}
\usage{data(cellular)}
\description{
The \code{cellular} data frame has 16 rows and 3 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{TNF}{Dose of TNF (U/ml) }
    \item{IFN}{Dose of IFN (U/ml) }
    \item{y}{Number of cells differentiating}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.19}
\examples{}
\keyword{datasets}
\eof
\name{chapman}
\alias{chapman}
\non_function{}
\title{Chapman data}
\usage{data(chapman)}
\description{
The \code{chapman} data frame has 200 rows and 7 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{age}{a numeric vector}
    \item{highbp}{a numeric vector}
    \item{lowbp}{a numeric vector}
    \item{chol}{a numeric vector}
    \item{height}{a numeric vector}
    \item{weight}{a numeric vector}
    \item{y}{a numeric vector}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.24}
\examples{}
\keyword{datasets}
\eof
\name{derailme}
\alias{derailme}
\non_function{}
\title{British Train Accidents.}
\usage{data(derailme)}
\description{
The \code{derailme} data frame has 67 rows and 5 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{Month}{a numeric vector}
    \item{Year}{a numeric vector}
    \item{Type}{a numeric vector}
    \item{TrainKm}{a numeric vector}
    \item{y}{a numeric vector}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.18}
\examples{}
\keyword{datasets}
\eof
\name{dialectric}
\alias{dialectric}
\non_function{}
\title{Dialectric data}
\usage{data(dialectric)}
\description{
The \code{dialectric} data frame has 128 rows and 3 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{time}{Time (weeks)}
    \item{temp}{Temperature (C)}
    \item{y}{dialectric breakdown strength in kilovolts}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.17}
\examples{}
\keyword{datasets}
\eof
\name{forbes}
\alias{forbes}
\non_function{}
\title{Forbes data}
\usage{data(forbes)}
\description{
Forbes' data on air pressure in the Alps and the boiling point of
water. \cr
The \code{forbes} data frame has 17 rows and 2 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{x}{Boiling point}
    \item{y}{100  log(pressure)}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.1}
\examples{}
\keyword{datasets}
\eof
\name{fwd.combn}
\alias{fwd.combn}
\alias{fwd.nCm}

\title{Generate all combinations of elements of x taken m at a time}
\description{
Generate all combinations of the elements of x taken m at a time.  If x is a positive integer, returns all combinations of the elements of seq(x) taken m at a time.
If argument \code{fun} is not null, applies a function given by the argument to each point.  
If simplify is \code{FALSE}, returns a list; else returns a vector or an array. Optional arguments \code{...} are passed unchanged to the function given by argument \code{fun}, if any.
}
\usage{
fwd.combn(x, m, fun = NULL, simplify = TRUE, \dots)
fwd.nCm(n, m, tol = 1e-08)
}
\arguments{
  \item{x}{a vector or a single value.}
  \item{n}{a positive integer.}
  \item{m}{a positive integer.}
  \item{fun}{a function to be applied to each combination.}
  \item{simplify}{logical, if \code{TRUE} returns a vector or an array, otherwise a list.}
  \item{tol}{optional, tolerance value.}
  \item{...}{optional arguments passed to \code{fun}.}
}
%\details{}
\value{Returns a vector or an array if \code{simplify = TRUE}, otherwise a list.
}
\references{Nijenhuis, A. and Wilf, H.S. (1978) \emph{Combinatorial 
Computers and Calculators}. NY: Academic Press.}
\author{Scott Chasalow}
\note{Renamed by Kjell Konis for inclusion in the Forward Library 11/2002} \examples{
fwd.combn(letters[1:4], 2)
fwd.combn(10, 5, min)      # minimum value in each combination
# Different way of encoding points:
fwd.combn(c(1,1,1,1,2,2,2,3,3,4), 3, tabulate, nbins = 4)
# Compute support points and (scaled) probabilities for a
# Multivariate-Hypergeometric(n = 3, N = c(4,3,2,1)) p.f.:
table(t(fwd.combn(c(1,1,1,1,2,2,2,3,3,4), 3, tabulate, nbins=4)))
}
\keyword{math}
\eof
\name{fwdglm}
\alias{fwdglm}
\alias{print.fwdglm}

\title{Forward Search in Generalized Linear Models}
\description{
This function applies the forward search approach to robust analysis in generalized linear models.
}

\usage{
fwdglm(formula, family, data, weights, na.action, contrasts = NULL, bsb = NULL, 
       balanced = TRUE, maxit = 50, epsilon = 1e-06, nsamp = 100, trace = TRUE)
}
\arguments{
  \item{formula}{a symbolic description of the model to be fit. The details of the model are the same as for glm.}
  \item{family}{a description of the error distribution and link function to be used in the model. See `family' for details.}
  \item{data}{an optional data frame containing the variables in the model. By default the variables are taken from the environment from which the function is called.}
  \item{weights}{an optional vector of weights to be used in the fitting process.}
  \item{na.action}{a function which indicates what should happen when the data contain `NA's. The default is set by the `na.action' setting of `options', and is `na.fail' if that is unset. The default is `na.omit'.}
  \item{contrasts}{an optional list. See the `contrasts.arg' of `model.matrix.default'.}
  \item{bsb}{an optional vector specifying a starting subset of observations to be used in the forward search. By default the ``best'' starting subset is chosen using the function \code{\link{lmsglm}} with control arguments provided by `nsamp'.}
  \item{balanced}{logical, for a binary response if \code{TRUE} the proportion of successes on the full dataset is approximately balanced during the forward search algorithm.}
  \item{maxit}{integer giving the maximal number of IWLS iterations. See \code{glm.control} for details.}
  \item{epsilon}{positive convergence tolerance epsilon. See \code{glm.control} for details.}
  \item{nsamp}{the initial subset for the forward search in generalized linear models is found by the function \code{\link{lmsglm}}. This argument allows to control how many subsets are used in the robust fitting procedure. The choices are: the number of samples (100 by the default) or `"all"'. Note that the algorithm tries to find `nsamp' good subsets or a maximum of 2*`nsamp' subsets.}
  \item{trace}{logical, if \code{TRUE} a message is printed for every ten iterations completed during the forward search.}
}
%\details{}
\value{
The function returns an object of class `"fwdglm"' with the following components:
\item{call}{the matched call.}
\item{Residuals}{a \eqn{(n x (n-p+1))} matrix of residuals.}
\item{Unit}{a matrix of units added (to a maximum of 5 units) at each step.}
\item{included}{a list with each element containing a vector of units included at each step of the forward search.}
\item{Coefficients}{a \eqn{((n-p+1) x p)} matrix of coefficients.}
\item{tStatistics}{a \eqn{((n-p+1) x p)} matrix of t statistics for the coefficients, i.e. coef.est/SE(coef.est).}
\item{Leverage}{a \eqn{(n x (n-p+1))} matrix of leverage values.}
\item{MaxRes}{a \eqn{((n-p) x 2)} matrix of max deviance residuals in the best subsets and \eqn{m}-th deviance residuals.}
\item{MinDelRes}{a \eqn{((n-p-1) x 2)} matrix of minimum deviance residuals out of best subsets and \eqn{(m+1)}-th deviance residuals.}
\item{ScoreTest}{a \eqn{((n-p) x 1)} matrix of score test statistics for a goodness of link test.}
\item{Likelihood}{a \eqn{((n-p) x 4)} matrix with columns containing: deviance, residual deviance, psuedo \eqn{R^2} (computed as \eqn{1-deviance/null.deviance}), dispersion parameter (computed as \eqn{\sum(pearson.residuals^2)/(m - p)}).}
\item{CookDist}{a \eqn{((n-p) x 1)} matrix of forward Cook's distances.}
\item{ModCookDist}{a \eqn{((n-p) x 5)} matrix of forward modified Cook's distances for the units (to a maximum of 5 units) included at each step.}
\item{Weights}{a \eqn{(n x (n-p))} matrix of weights used at each step of the forward search.}
\item{inibsb}{a vector giving the best starting subset chosen by \code{\link{lmsglm}}.}
\item{binary.response}{logical, equal to \code{TRUE} if binary response.}
}
\references{Atkinson, A.C. and Riani, M. (2000), \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapter 6.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{summary.fwdglm}}, \code{\link{plot.fwdglm}}, \code{\link{fwdlm}}, \code{\link{fwdsco}}.  
}
\examples{ 
data(cellular)
cellular$TNF <- as.factor(cellular$TNF)
cellular$IFN <- as.factor(cellular$IFN)
mod <- fwdglm(y ~ TNF + IFN, data=cellular, family=poisson(log), nsamp=200)
summary(mod)
\dontrun{plot(mod)}
plot(mod, 1)
plot(mod, 5)
plot(mod, 6, ylim=c(-3, 20))
plot(mod, 7)
plot(mod, 8)
}
\keyword{robust}
\keyword{regression}
\keyword{models}
\eof
\name{fwdlm}
\alias{fwdlm}
\alias{print.fwdlm}

\title{Forward Search in Linear Regression}
\description{
This function applies the forward search approach to robust analysis in linear regression models.
}
\usage{
fwdlm(formula, data, nsamp = "best", x = NULL, y = NULL, intercept = TRUE, 
      na.action, trace = TRUE)
}
\arguments{
  \item{formula}{a symbolic description of the model to be fit. The details of the model are the same as for lm.}
  \item{data}{an optional data frame containing the variables in the model. By default the variables are taken from the environment from which the function is called.}
  \item{nsamp}{the initial subset for the forward search in linear regression is found by fitting the regression model with the R function lmsreg (in package `\code{lqs}'. This argument allows to control how many subsets are used in the Least  Median of Squares regression. The choices are: the number of samples or `"best"' (the default) or `"exact"' or `"sample"'. For details see help(lmsreg).}
  \item{x}{A matrix of predictors values (if no formula is provided).}
  \item{y}{A vector of response values (if no formula is provided).}
  \item{intercept}{Logical for the inclusion of the intercept (if no formula is provided).}
  \item{na.action}{a function which indicates what should happen when the data contain `NA's. The default is set by the `na.action' setting of `options', and is `na.fail' if that is unset. The default is `na.omit'.}
  \item{trace}{logical, if \code{TRUE} a message is printed for every ten iterations completed during the forward search.}
}
%\details{}
\value{The function returns an object of class `"fwdlm"' with the following components:
\item{call}{the matched call.}
\item{Residuals}{a \eqn{(n x (n-p+1))} matrix of residuals.}
\item{Unit}{a matrix of units added (to a maximum of 5 units) at each step.}
\item{included}{a list with each element containing a vector of units included at each step of the forward search.}
\item{Coefficients}{a \eqn{((n-p+1) x p)} matrix of coefficients.}
\item{tStatistics}{a \eqn{((n-p+1) x p)} matrix of t statistics for the coefficients.}
\item{CookDist}{a \eqn{((n-p) x 1)} matrix of forward Cook's distances.}
\item{ModCookDist}{a \eqn{((n-p) x 5)} matrix of forward modified Cook's distances for the units (to a maximum of 5 units) included at each step.}
\item{Leverage}{a \eqn{(n x (n-p+1))} matrix of leverage values.}
\item{S2}{a \eqn{((n-p+1) x 2)} matrix with 1st column containing \eqn{S^2} and the 2nd column \eqn{R^2}.}
\item{MaxRes}{a \eqn{((n-p) x 1)} matrix of max studentized residuals.}
\item{MinDelRes}{a \eqn{((n-p-1) x 1)} matrix of minimum deletion residuals.}
\item{StartingModel}{a `"lqs"' object providing the the Least Median of Squares regression fit used to select the starting subset.}
}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapters 2-3.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{summary.fwdlm}}, \code{\link{plot.fwdlm}}, \code{\link{fwdsco}}, \code{\link{fwdglm}}.  
}
\examples{
data(forbes)
plot(forbes, xlab="Boiling point", ylab="100  log(pressure)")
mod <- fwdlm(y ~ x, data=forbes)
summary(mod)
\dontrun{plot(mod)}
plot(mod, 1)
plot(mod, 6, ylim=c(-3, 1000))
}
\keyword{robust}
\keyword{regression}
\keyword{models}
\eof
\name{fwdsco}
\alias{fwdsco}
\alias{print.fwdsco} 

\title{Forward Search Transformation in Linear Regression}
\description{
This function applies the forward search approach to the Box-Cox transformation of response in linear regression models.
}
\usage{
fwdsco(formula, data, nsamp = "best", lambda = c(-1, -0.5, 0, 0.5, 1), 
       x = NULL, y = NULL, intercept = TRUE, na.action, trace = TRUE)
}
\arguments{
  \item{formula}{a symbolic description of the model to be fit. The details of the model are the same as for lm.}
  \item{data}{an optional data frame containing the variables in the model. By default the variables are taken from the environment from which the function is called.}
  \item{nsamp}{the initial subset for the forward search in linear regression is found by fitting the regression model with the R function lmsreg (in package `\code{lqs}'). This argument allows to control how many subsets areused in the Least  Median of Squares regression. The choices are: the number of samples or `"best"' (the default) or `"exact"' or `"sample"'. For details see help(lmsreg).}
  \item{lambda}{a vector (or a single numerical value) of lambda values for the response transformation.}
  \item{x}{A matrix of predictors values (if no formula is provided).}
  \item{y}{A vector of response values (if no formula is provided).}
  \item{intercept}{Logical for the inclusion of the intercept (if no formula is provided).}
  \item{na.action}{a function which indicates what should happen when the data contain `NA's. The default is set by the `na.action' setting of `options', and is `na.fail' if that is unset. The default is `na.omit'.}
  \item{trace}{logical, if \code{TRUE} a message is printed for every ten iterations completed during the forward search.}
}
%\details{}
\value{
The function returns an object of class `"fwdsco"' with the following components:
\item{call}{the matched call.}
\item{Likelihood}{a \eqn{((n-p+1) x n.lambda)} matrix of likelihood values.}
\item{ScoreTest}{a \eqn{((n-p+1) x n.lambda)} matrix of score test statistic values.}
\item{Unit}{a list with an element for each lambda values. Each element provides a matrix of units added (to a maximum of 5 units) at each step of the forward search.}
\item{Input}{a list with \eqn{n}, \eqn{p} and the vector of lambda values used.}
\item{x}{The design matrix.}
\item{y}{The vector for the response.}
}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapter 4.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{summary.fwdsco}}, \code{\link{plot.fwdsco}}, \code{\link{fwdlm}}, \code{\link{fwdglm}}.  
}
\examples{
data(wool)
mod <- fwdsco(y ~ x1 + x2 + x3, data = wool)
summary(mod)
plot(mod, plot.mle=FALSE)
plot(mod, plot.Sco=FALSE, plot.Lik=TRUE)
}
\keyword{robust}
\keyword{regression}
\keyword{models}
                
\eof
\name{hawkins}
\alias{hawkins}
\non_function{}
\title{Hawkins' data}
\usage{data(hawkins)}
\description{
The \code{hawkins} data frame has 128 rows and 9 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{x1}{a numeric vector}
    \item{x2}{a numeric vector}
    \item{x3}{a numeric vector}
    \item{x4}{a numeric vector}
    \item{x5}{a numeric vector}
    \item{x6}{a numeric vector}
    \item{x7}{a numeric vector}
    \item{x8}{a numeric vector}
    \item{y}{a numeric vector}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.4}
\examples{}
\keyword{datasets}
\eof
\name{kinetics}
\alias{kinetics}
\non_function{}
\title{Kinetics data}
\usage{data(kinetics)}
\description{Kinetics data (from Becton-Dickenson)  \cr
The \code{kinetics} data frame has 19 rows and 5 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{Substrate}{substrate indicator}
    \item{I0}{Inhibitor concentration}
    \item{I3}{Inhibitor concentration}
    \item{I10}{Inhibitor concentration}    
    \item{I30}{Inhibitor concentration}
    \item{y}{initial velocity}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.12}
\examples{}
\keyword{datasets}
\eof
\name{lakes}
\alias{lakes}
\non_function{}
\title{Lakes data}
\usage{data(lakes)}
\description{
The \code{lakes} data frame has 29 rows and 3 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{x1}{average influent nitrogenon concentration}
    \item{x2}{a numeric vector}
    \item{y}{a numeric vector}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.14}
\examples{}
\keyword{datasets}
\eof
\name{leafpine}
\alias{leafpine}
\non_function{}
\title{Pine data}
\usage{data(leafpine)}
\description{
The \code{leafpine} data frame has 70 rows and 3 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{x1}{a numeric vector}
    \item{x2}{a numeric vector}
    \item{y}{a numeric vector}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.10}
\examples{}
\keyword{datasets}
\eof
\name{lmsglm}
\alias{lmsglm}

\title{Forward Search in Generalized Linear Models}
\description{
This function computes the Least Median Square robust fit for generalized linear models using deviance residuals.}

\usage{
lmsglm(x, y, family, weights, offset, n.samples = 100, max.samples = 200, epsilon = 1e-04, maxit = 50, trace = FALSE)
}
\arguments{
  \item{x}{a matrix or data frame containing the explanatory variables.}
  \item{y}{the response: a vector of length the number of rows of `x'.}
  \item{family}{a description of the error distribution and link function to be used in the model. See `family' for details.}
  \item{weights}{an optional vector of weights to be used in the fitting process.}
  \item{offset}{optional, a priori known component to be included in the linear predictor during fitting.}
  \item{n.samples}{number of good subsets to fit. It can be a numeric value or `"all"'.}
  \item{max.samples}{maximal number of subsets to fit. By default is set to twice `n.samples'.}
  \item{epsilon}{positive convergence tolerance epsilon. See \code{glm.control} for details.}
  \item{maxit}{integer giving the maximal number of IWLS iterations. See \code{glm.control} for details.}
  \item{trace}{logical, if \code{TRUE} a message is printed for every ten iterations completed during the search.}
}
\details{This function is used by  \code{fwdglm} to select the
starting subset for the forward search. For this reason, users do not
generally need to use it.}
\value{
The function returns a list with the following components:
\item{bsb}{a vector giving the best subset found}
\item{dev.res}{a vector giving the deviance residuals for all the observations}
\item{message}{a short message about the status of the algorithm}
\item{model}{the model provided by `glm.fit' using the units in the best subset found}
}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapter 6.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{fwdglm}}, \code{\link{fwdlm}}, \code{\link[lqs]{lmsreg}}, \code{\link{fwdsco}}.
}
\examples{}
\keyword{robust}
\keyword{regression}
\keyword{models}
\eof
\name{mice}
\alias{mice}
\non_function{}
\title{Mice data}
\usage{data(mice)}
\description{
The \code{mice} data frame has 14 rows and 4 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{dose}{dose level}
    \item{prep}{factor preparation: 0= Standard preparation, 1= Test preparation}
    \item{conv}{number with convultion}
    \item{total}{Total}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust
Diagnostic Regression Analysis}, First Edition. New York: Springer,
Table A.21}
\examples{}
\keyword{datasets}
\eof
\name{molar}
\alias{molar}
\non_function{}
\title{Molar data}
\usage{data(molar)}
\description{Radioactivity versus molar concentration of nifedipene \cr
The \code{molar} data frame has 15 rows and 2 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{x}{log10(NIF concentration)}
    \item{y}{Total counts for \eqn{5 \times 10^-10} Molar NTD additive}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.1}
\examples{}
\keyword{datasets}
\eof
\name{mussels}
\alias{mussels}
\non_function{}
\title{Mussels data}
\usage{data(mussels)}
\description{
The \code{mussels} data frame has 82 rows and 5 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{W}{width}
    \item{H}{height}
    \item{L}{length}
    \item{S}{shell mass}
    \item{M}{mass}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.9}
\examples{}
\keyword{datasets}
\eof
\name{ozone}
\alias{ozone}
\non_function{}
\title{Ozone data}
\usage{data(ozone)}
\description{Ozone concentration at Upland, CA. \cr
The \code{ozone} data frame has 80 rows and 9 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{x1}{a numeric vector}
    \item{x2}{a numeric vector}
    \item{x3}{a numeric vector}
    \item{x4}{a numeric vector}
    \item{x5}{a numeric vector}
    \item{x6}{a numeric vector}
    \item{x7}{a numeric vector}
    \item{x8}{a numeric vector}
    \item{y}{ Ozone concentration (ppm)}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.7}
\examples{}
\keyword{datasets}
\eof
\name{plot.fwdglm}
\alias{plot.fwdglm}

\title{Forward Search in Generalized Linear Models}
\description{
This function plots the results of a forward search analysis in generalized linear models.}

\usage{
\method{plot}{fwdglm}(x, which.plots = 1:11, squared = FALSE, scaled =FALSE, 
     ylim = NULL, xlim = NULL, th.Res = 4, th.Lev = 0.25, sig.Tst =2.58, 
     sig.score = 1.96, plot.pf = FALSE, labels.in.plot = TRUE, \dots)
}
\arguments{
  \item{x}{a `"fwdglm"' object.}
  \item{which.plots}{select which plots to draw, by default all. Each graph is addressed by an integer: 
  \enumerate{\item deviance residuals
             \item leverages
             \item maximum deviance residuals
             \item minimum deviance residuals 
             \item coefficients
             \item t statistics, i.e. coef.est/SE(coef.est)
             \item likelihood matrix: deviance, deviance explained, pseudo R-squared, dispersion parameter
             \item score statistic for the goodness of link test
             \item forward Cook's distances 
             \item modified forward Cook's distances 
             \item weights used at each step of the forward search for the units included
}
}
  \item{squared}{logical, if \code{TRUE} plots squared deviance residuals.}
  \item{scaled}{logical, if \code{TRUE} plots scaled coefficient estimates.}
  \item{ylim}{a two component vector for the min and max of the y axis.}
  \item{xlim}{a two component vector for the min and max of the x axis.}
  \item{th.Res}{numerical, a threshold for labelling the residuals.}
  \item{th.Lev}{numerical, a threshold for labelling the leverages.}
  \item{sig.Tst}{numerical, a value used to draw the confidence interval on the plot of the t statistics.}
  \item{sig.score}{numerical, a value used to draw the confidence interval on the plot of the score test statistic.}
  \item{plot.pf}{logical, in case of binary response if \code{TRUE} graphs contain all the step of the forward search, otherwise only those in which there is no perfect fit.}
  \item{labels.in.plot}{logical, if \code{TRUE} units are labelled in the plots when required.}
  \item{...}{further arguments passed to or from other methods.}
}
%\details{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapter 6.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{fwdglm}}, \code{\link{fwdlm}}, \code{\link{fwdsco}}.  
}
\examples{ 
\dontrun{data(cellular)}
\dontrun{mod <- fwdglm(y ~ as.factor(TNF) + as.factor(IFN), data=cellular, 
              family=poisson(log), nsamp=200)}
\dontrun{summary(mod)}
\dontrun{plot(mod)}
}
\keyword{robust}
\keyword{regression}
\keyword{models}
\eof
\name{plot.fwdlm}
\alias{plot.fwdlm}
\title{Forward Search in Linear Regression}
\description{
This function plots the results of a forward search analysis in linear regression models.
}
\usage{
\method{plot}{fwdlm}(x, which.plots = 1:10, squared = FALSE, scaled = TRUE, 
     ylim = NULL, xlim = NULL, th.Res = 2, th.Lev = 0.25, sig.Tst = 2.58, 
     labels.in.plot = TRUE, \dots)
}
\arguments{
  \item{x}{a `"fwdlm"' object.}
  \item{which.plots}{select which plots to draw, by default all. Each graph is addressed by an integer: 
  \enumerate{\item scaled residuals
             \item leverages
             \item maximum studentized residuals
             \item minimum deletion residuals 
             \item coefficients
             \item statistics
             \item forward Cook's distances 
             \item modified forward Cook's distances 
             \item \eqn{S^2} values
             \item \eqn{R^2} values
}
}
  \item{squared}{logical, if \code{TRUE} plots squared residuals.}
  \item{scaled}{logical, if \code{TRUE} plots scaled coefficient estimates.}
  \item{ylim}{a two component vector for the min and max of the y axis.}
  \item{xlim}{a two component vector for the min and max of the x axis.}
  \item{th.Res}{numerical, a threshold for labelling the residuals.}
  \item{th.Lev}{numerical, a threshold for labelling the leverages.}
  \item{sig.Tst}{numerical, a value (on the scale of the t statistics) used to draw the confidence interval on the plot of the t statistics.}
  \item{labels.in.plot}{logical, if \code{TRUE} units are labelled in the plots when required.}
  \item{...}{further arguments passed to or from other methods.}
}
%\details{}
\value{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapters 2-3.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{fwdlm}}, \code{\link{fwdsco}}, \code{\link{fwdglm}}.  
}
\examples{
\dontrun{data(forbes)}
\dontrun{plot(forbes)}
\dontrun{mod <- fwdlm(Log.Pressure ~ Boiling.point, data=forbes)}
\dontrun{summary(mod)}
\dontrun{plot(mod)}
}
\keyword{robust}
\keyword{regression}
\keyword{models}


\eof
\name{plot.fwdsco}
\alias{plot.fwdsco}
\title{Forward Search Transformation in Linear Regression}
\description{This function plots the results of a forward search analysis for Box-Cox transformation of response in linear regression models.}
\usage{
\method{plot}{fwdsco}(x, plot.Sco = TRUE, plot.Lik = FALSE, th.Sco = 2.58, 
      plot.mle = TRUE, ylim = NULL, xlim = NULL, \dots)
}
\arguments{
  \item{x}{a `"fwdsco"' object.}
  \item{plot.Sco}{logical, if \code{TRUE} plots the score test statistic at each step of the forward search for each lambda value.}
  \item{plot.Lik}{logical, if \code{TRUE} plots the likelihood value at each step of the forward search for each lambda value.}
  \item{th.Sco}{numerical, a value used to draw the confidence interval on the plot of the score test statistic.}
  \item{plot.mle}{logical, if \code{TRUE} adds a point at the maximum likelihood value for the transformation computed in the final step, i.e. on the full dataset.}
  \item{ylim}{a two component vector for the min and max of the y axis.}
  \item{xlim}{a two component vector for the min and max of the x axis.}
  \item{...}{further arguments passed to or from other methods.}
}
\details{}
\value{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapters 2-3.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{fwdsco}}, \code{\link{fwdlm}}, \code{\link{fwdglm}}.  
}
\examples{
\dontrun{data(wool)}
\dontrun{mod <- fwdsco(y ~ x1 + x2 + x3, data = wool)}
\dontrun{plot(mod, plot.mle=FALSE)}
\dontrun{plot(mod, plot.Sco=FALSE, plot.Lik=TRUE)}
}
\keyword{robust}
\keyword{regression}
\keyword{models}
\eof
\name{poison}
\alias{poison}
\non_function{}
\title{Poison data}
\usage{data(poison)}
\description{Box and Cox poison data. Survival times in 10 hour units
of animals in a 3 4  factorial experiment. \cr
The \code{poison} data frame has 48 rows and 3 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{time}{a numeric vector}
    \item{poison}{a factor}
    \item{treat}{a factor with levels}
    \item{treat}{\code{A} }
    \item{treat}{\code{B} }
    \item{treat}{\code{C} }
    \item{treat}{\code{D} }
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.8}
\examples{}
\keyword{datasets}
\eof
\name{rainfall}
\alias{rainfall}
\non_function{}
\title{Rainfall data}
\usage{data(rainfall)}
\description{Toxoplasmosis data. \cr
The \code{rainfall} data frame has 34 rows and 3 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{Rain}{mm of rain}
    \item{Cases}{cases of toxoplasmosis}
    \item{Total}{total}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.22}
\examples{}
\keyword{datasets}
\eof
\name{salinity}
\alias{salinity}
\non_function{}
\title{Salinity data}
\usage{data(salinity)}
\description{
The \code{salinity} data frame has 28 rows and 4 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{x1}{Lagged salinity}
    \item{x2}{Trend}
    \item{x3}{Water flow}
    \item{y}{Salinity}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.6}
\examples{}
\keyword{datasets}
\eof
\name{scglm}
\alias{scglm}

\title{Goodness of Link Test in GLM}
\description{Computes the score test statistic for the goodness of link test in generalized linear models.}
\usage{
scglm(x, y, family, weights, beta, phi = 1, offset)
}
\arguments{
  \item{x}{a matrix or data frame containing the explanatory variables.}
  \item{y}{the response: a vector of length the number of rows of `x'.}
  \item{family}{a description of the error distribution and link function to be used in the model. See `family' for details.}
  \item{weights}{an optional vector of weights to be used in the fitting process.}
  \item{beta}{a vector of coefficients estimates}
  \item{phi}{the dispersion parameter}
  \item{offset}{optional, a priori known component to be included in the linear predictor during fitting.}
}
\details{See pag. 200--201 of Atkinson and Riani (2000).}
\value{Return the value of the score test statistic.}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapter 6.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{fwdglm}}, \code{\link{fwdlm}}, \code{\link{score.s}}.
}
%\examples{}
\keyword{robust}
\keyword{regression}
\keyword{models}
\eof
\name{score.s}
\alias{score.s}
\alias{lambda.mle}

\title{Score test for the Box-Cox transformation of the response}
\description{Computes the approximate score test statistic for the Box-Cox transformation}
\usage{
score.s(x, y, la, tol = 1e-20)
lambda.mle(x, y, init = c(-2, 2), tol = 1e-04)
}
\arguments{
  \item{x}{a matrix or data frame containing the explanatory variables.}
  \item{y}{the response: a vector of length the number of rows of `x'.}
  \item{la}{the value of the lambda parameter.}
  \item{tol}{tolerance value used to check for full rank matrix.}
  \item{init}{range of values to search for MLE.}
}
\details{See pag. 82--86 of Atkinson and Riani (2000).}
\value{Return a list with two components:
\item{Score}{the value of the score test statistic}
\item{Likelihood}{the value of the likelihood}
}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapter 4.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{fwdsco}}, \code{\link{fwdlm}}, \code{\link{fwdglm}}.
}
%\examples{}
\keyword{robust}
\keyword{regression}
\keyword{models}
\eof
\name{stackloss}
\alias{stackloss}
\non_function{}
\title{Stackloss data}
\usage{data(stackloss)}
\description{Brownlee?s stack loss data. \cr
The \code{stackloss} data frame has 21 rows and 4 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{Air}{Air flow }
    \item{Temp}{Cooling water inlet temperature}
    \item{Conc}{Acid concentration}
    \item{Loss}{Stack loss}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.5}
\examples{}
\keyword{datasets}
\eof
\name{summary.fwdglm}
\alias{summary.fwdglm}
\alias{print.summary.fwdglm}

\title{Summarizing Fit of Forward Search in Generalized Linear Regression}
\description{
`summary' method for class `"fwdglm"'.
}
\usage{
\method{summary}{fwdglm}(object, steps = "auto", remove.perfect.fit = TRUE, \dots)
}
\arguments{
  \item{object}{an object of class `"fwdglm"'.}
  \item{steps}{the number of forward steps to show.}
  \item{remove.perfect.fit}{logical, controlling if perfect fit steps should be removed (only apply to binary responses).}
  \item{...}{further arguments passed to or from other methods.}
}
%\details{}
\value{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapter 6.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{fwdglm}}.
}
%\examples{}
\keyword{robust}
\keyword{regression}
\keyword{models}
\eof
\name{summary.fwdlm}
\alias{summary.fwdlm}
\alias{print.summary.fwdlm}

\title{Summarizing Fit of Forward Search in Linear Regression}
\description{
`summary' method for class `"fwdlm"'.
}
\usage{
\method{summary}{fwdlm}(object, steps = "auto", \dots)
}
\arguments{
  \item{object}{an object of class `"fwdlm"'.}
  \item{steps}{the number of forward steps to show.}
  \item{...}{further arguments passed to or from other methods.}
}
%\details{}
\value{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapters 2-3.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{fwdlm}}.
}
%\examples{}
\keyword{robust}
\keyword{regression}
\keyword{models}
\eof
\name{summary.fwdsco}
\alias{summary.fwdsco}
\alias{print.summary.fwdsco}

\title{Summarizing Fit of Forward Search Transformation in Linear Regression}
\description{
`summary' method for class `"fwdsco"'.
}
\usage{
\method{summary}{fwdsco}(object, steps = "auto", lambdaMLE = FALSE, \dots)
}
\arguments{
  \item{object}{an object of class `"fwdsco"'.}
  \item{steps}{the number of forward steps to show.}
  \item{lambdaMLE}{logical, controlling if the MLE of lambda calculated on the full dataset must be be shown.}  
  \item{...}{further arguments passed to or from other methods.}
}
%\details{}
\value{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Chapter 4.}
\author{Originally written for S-Plus by:
Kjell Konis \email{kkonis@insightful.com} and Marco Riani \email{mriani@unipr.it} \cr
Ported to R by Luca Scrucca \email{luca@stat.unipg.it}}
\seealso{
\code{\link{fwdsco}}.
}
%\examples{}
\keyword{robust}
\keyword{regression}
\keyword{models}
\eof
\name{vaso}
\alias{vaso}
\non_function{}
\title{Vaso data}
\usage{data(vaso)}
\description{Finney's data on vaso-contriction in the skin of the digits. \cr
The \code{vaso} data frame has 39 rows and 3 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{volume}{volume}
    \item{rate}{rate}
    \item{y}{response: 0= nonoccurrence, 1= occurrence}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer, Table A.23}
\examples{}
\keyword{datasets}
\eof
\name{wool}
\alias{wool}
\non_function{}
\title{Wool data}
\usage{data(wool)}
\description{
Number of cycles to failure of samples of worsted yarn in a 33 experiment. \cr
The \code{wool} data frame has 27 rows and 4 columns.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{x1}{factor levels: -1, 0, 1}
    \item{x2}{factor levels: -1, 0, 1}
    \item{x3}{factor levels: -1, 0, 1}
    \item{y}{cycles to failure a numeric vector}
  }
}
\details{}
\source{}
\references{Atkinson, A.C. and Riani, M. (2000),  \emph{Robust Diagnostic Regression Analysis}, First Edition. New York: Springer,  Table A.3}
\examples{}
\keyword{datasets}
\eof
